<?php
/*
Plugin Name: Tab Override
Plugin URI: http://tinsology.net/plugins/tab-override/
Description: Causes tabs to function as they would in a text editor rather than a browser
Version: 2.1
Author: Mathew Tinsley, Bill Bryant
Author URI: http://tinsology.net/
License: GPL2
*/

/*  Copyright 2010  Mathew Tinsley  (email : tinsley@tinsology.net),
                    Bill Bryant     (email : bill@wjbryant.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

function tab_override_settings_page() {
?>
<div class="wrap">
<h2>Tab Override Settings</h2>
<form method="post" action="options.php">
	<?php settings_fields('tab-override-settings-group'); ?>
	<table class="form-table">
		<tr valign="top">
			<th scope="row"><label for="tab_override_tab_size">Tab size:</label></th>
			<td><input type="text" id="tab_override_tab_size" name="tab_override_tab_size" value="<?php echo get_option('tab_override_tab_size'); ?>" /></td>
			<td><em>Leave blank to use the tab character (default)</em></td>
		</tr>
	</table>
	<p class="submit">
		<input type="submit" class="button-primary" value="<?php _e('Save Changes'); ?>" />
	</p>
	<div style="text-align: right;">
	<a href="http://tinsology.net/plugins/tab-override/">Documentation</a> | <a href="http://wjbryant.com/">http://wjbryant.com/</a>
	</div>
</form>
</div>
<?php
}

function tab_override_register_settings() {
	register_setting('tab-override-settings-group', 'tab_override_tab_size');
}

function tab_override_create_menu() {
	add_options_page('Tab Override Plugin Settings', 'Tab Override', 'administrator', 'tab-override-settings', 'tab_override_settings_page');
	add_action('admin_init', 'tab_override_register_settings');
}

add_action('admin_menu', 'tab_override_create_menu');

function tab_override_add_invocation_script() {
	$tabSize = get_option('tab_override_tab_size');
	$setTabSize = is_numeric($tabSize) && $tabSize > 0 ? "jQuery.fn.tabOverride.setTabSize($tabSize);" : '';
	echo "<script type=\"text/javascript\">{$setTabSize}jQuery('#content,#replycontent,#newcontent').tabOverride()</script>\r\n";
}

function tab_override_add_scripts($hook_suffix) {
	$admin_edit_pages = array(
		'index.php',
		'post.php',
		'post-new.php',
		'page.php',
		'page-new.php',
		'edit-comments.php',
		'comment.php',
		'theme-editor.php',
		'plugin-editor.php'
	);
	
	if (in_array($hook_suffix, $admin_edit_pages)) {
		wp_enqueue_script('tab-override', WP_PLUGIN_URL . '/tab-override/jquery.taboverride-1.0.min.js', array('jquery'), '1.0');
		add_action('admin_print_footer_scripts', 'tab_override_add_invocation_script');
	}
}

add_action('admin_enqueue_scripts', 'tab_override_add_scripts');